//---------------------------------------------------------------------
//	C̏
//---------------------------------------------------------------------
#include <windows.h>
#include <ole2.h>
#include <vfw.h>
#include <process.h>

#include "auo_mt.h"

#define UNDEFINED_FORMAT 0xffffffffU

//o̓Xbh̊Jn
bool AUO_MT::start_thread(void)
{
	//̃`FbN
	if(!pinfo_orig || !block_event || !slp_event || buf_num <= 0
		|| !img_data_n || !img_flag || !img_flag_n)
	{
		show_message_box("o̓Xbh̏Ɏs܂B");
		return false;
	}

	thread = (HANDLE)_beginthreadex(NULL, 0, th_output, this, 0, &thread_id);
	if(0 == thread){
		thread_id = 0;
		return false;
	}

	//vCIeB[{̂Ɠɂ
	int pri = GetThreadPriority(GetCurrentThread());
	if(pri != THREAD_PRIORITY_ERROR_RETURN){
		SetThreadPriority(thread, pri);
	}

	return true;
}

BOOL AUO_MT::wait_thread(void)
{
	DWORD ret = 0;

	if(thread){
		WaitForSingleObject(thread, INFINITE);

		//IR[h̎擾
		GetExitCodeThread(thread, &ret);
		CloseHandle(thread);

		thread = 0;
		thread_id = 0;
	}

	//J
	delete[] img_data_n;
	delete[] img_flag;
	delete[] img_flag_n;
	VirtualFree(img_data, 0, MEM_RELEASE);
	img_data_n = img_flag = img_flag_n = NULL;
	img_data = NULL;

	return (BOOL)ret;
}

//OUTPUT_INFȌ
bool AUO_MT::init_output(OUTPUT_INFO *oip)
{
	//|C^̕ۑƃRs[
	pinfo_orig = oip;
	oinfo = *oip;

	//oAPȈ㏑
	oinfo.func_get_video		= func_get_video_mt;
	oinfo.func_get_audio		= func_get_audio_mt;
	oinfo.func_is_abort			= func_is_abort_mt;
	oinfo.func_rest_time_disp	= func_rest_time_disp_mt;
	oinfo.func_get_flag			= func_get_flag_mt;
	oinfo.func_update_preview	= func_update_preview_mt;
	oinfo.func_get_video_ex		= func_get_video_ex_mt;

	//
	init_param0();

	if(buf_num < 1){
		show_message_box("ǂ݃obt@ُłBĐݒ肵ĂB");
		return false;
	}
	if(!ptbl){
		show_message_box("o̓vOCIĂ܂BĐݒ肵ĂB");
		return false;
	}

	///obt@̊m

	//ꉞ炩ߊJĂ
	delete[] img_data_n;
	delete[] img_flag;
	delete[] img_flag_n;

	//摜pobt@͌Ŋmۂ
	VirtualFree(img_data, 0, MEM_RELEASE);
	img_data = NULL;

	img_flag = new(std::nothrow) int[buf_num];
	img_data_n = new(std::nothrow) int[buf_num];
	img_flag_n = new(std::nothrow) int[buf_num];

	if(!img_flag || !img_data_n || !img_flag_n){
		delete[] img_data_n;
		delete[] img_flag;
		delete[] img_flag_n;
		img_data_n = img_flag = img_flag_n = NULL;

		show_message_box("mۂł܂łB"
			"ǂ݃obt@炵Ă݂ĂB");
		return false;
	}

	//̈̏
	for(int i=0; i<buf_num; ++i){
		img_flag[i] = 0;
		img_data_n[i] = -1;
		img_flag_n[i] = -1;
	}

	return true;
}

void AUO_MT::init_param0(void)
{
	//o͊JnOɕKvȈꕔp[^̏
	img_data_cur = img_flag_cur = 0;
	req = REQ_NONE;
	get_img_fmt = img_format = UNDEFINED_FORMAT;

	get_img_frame = -1;
	get_flag_frame = -1;

	get_audio_start = get_audio_length = 0;
	get_audio_read = NULL;
	get_audio_ret = NULL;

	req_abort = FALSE;
	req_abort_chk = req_update_prv = false;
	rest_disp_now = rest_disp_total = -1;
	rest_disp_now_old = rest_disp_total_old = -1;
}

//C֐
bool AUO_MT::output_start(void)
{
	bool loop = true;
	bool proceeded = false;

	//ǂݕi1:2炢ɂĂj
	const int prv = (buf_num-1)/3;
	const int nxt = (2*buf_num)/3;

	//XbhN
	SetEvent(block_event);

	while(loop){ //main loop
		switch(req){
			case REQ_NONE:
				proceeded = false;
				///ǂ݂s
				if(!req_abort){
					//C[W̐ǂ
					proceeded = read_ahead_video(prv, nxt);

					//tO̐ǂ
					proceeded |= read_ahead_flag(prv, nxt);
				}

				//邱Ƃ̂ő҂ɓ
				if(!proceeded){
#if 1
					if(WAIT_OBJECT_0 == WaitForSingleObject(slp_event, 500)){
						ResetEvent(slp_event);
					}
#else
					//debug
					DWORD ret = WaitForSingleObject(slp_event, 250);
					if(WAIT_OBJECT_0 == ret){
						ResetEvent(slp_event);
					}else if(WAIT_TIMEOUT == ret){
						ResetEvent(slp_event);
					}
#endif
				}
				break;
			case REQ_GET_AUDIO:
				//I[fBITv̎擾
				req_audio_proc();
				req = REQ_NONE;
				SetEvent(block_event);
				break;
			case REQ_GET_FLAG:
				//tO̎擾(cache miss)
				req_flag_proc();
				req = REQ_NONE;
				SetEvent(block_event);
				break;
			case REQ_GET_VIDEO_EX:
				//摜̎擾(cache miss)
				req_video_proc();
				req = REQ_NONE;
				SetEvent(block_event);
				break;
			case REQ_EXIT: //o̓vOCIꍇ
			default:
				loop = false;
				break;
		}

		//񓯊֐̏
		async_func_proc();

	} //while(loop){ //main loop

	return true;
}

///AUO_MT::output_start(void)Ă΂֐
//Video̐ǂ
bool AUO_MT::read_ahead_video(const int &prv, const int &nxt)
{
	int i,j,s,e;
	bool read = false;

	//tH[}bgw肳ĂȂƂ͉Ȃ
	if(UNDEFINED_FORMAT != img_format){
		s = img_data_cur - prv;
		if(s < 0) s = 0;
		e = img_data_cur + nxt;
		if(e > oinfo.n) e = oinfo.n;
		for(j=s; j<e; ++j){
			i = j%buf_num;
			if(img_data_n[i] != j){
				//֐Ă
				img_data_n[i] = -1;
				void *p = pinfo_orig->func_get_video_ex(j, img_format);
				if(p){
					memcpy(img_data + (i * img_data_offs), p, img_data_size);
					img_data_n[i] = j;
				}else{
					//fԂɂ
					req_abort = TRUE;
				}
				read = true;
				break;
			}
		}
	}

	return read;
}

//tO̐ǂ
bool AUO_MT::read_ahead_flag(const int &prv, const int &nxt)
{
	int i,j,s,e;
	bool read = false;

	s = img_flag_cur - prv;
	if(s < 0) s = 0;
	e = img_flag_cur + nxt;
	if(e > oinfo.n) e = oinfo.n;
	for(j=s; j<e; ++j){
		i = j%buf_num;
		if(img_flag_n[i] != j){
			//֐Ă
			img_flag_n[i] = -1;
			img_flag[i] = pinfo_orig->func_get_flag(j);
			img_flag_n[i] = j;
			read = true;
			break;
		}
	}

	return read;
}

//𓯊ŗvꂽꍇ
void AUO_MT::req_audio_proc(void)
{
	if(!req_abort){
		get_audio_ret = pinfo_orig->func_get_audio(
			get_audio_start, get_audio_length, get_audio_read);
	}else{
		get_audio_ret = NULL;
		*get_audio_read = 0;
	}
}

//tO𓯊ŗvꂽꍇ
void AUO_MT::req_flag_proc(void)
{
	if(!req_abort){
		int i = get_flag_frame%buf_num;
		if(img_flag_n[i] != get_flag_frame){
			//֐Ă
			img_flag_n[i] = get_flag_frame;
			img_flag[i] = pinfo_orig->func_get_flag(get_flag_frame);
		}
	}
}

//rfI𓯊ŗvꂽꍇ
void AUO_MT::req_video_proc(void)
{
	if(!req_abort){
		int i = get_img_frame%buf_num;

		//tH[}bgύXꂽ
		if(img_format != get_img_fmt){
			if(!on_format_change()){
				//tH[}bgύXs
				req_abort = TRUE;
				return;
			}
		}

		if(img_data_n[i] != get_img_frame){
			//֐Ă
			void *p;

			img_data_n[i] = get_img_frame;
			p = pinfo_orig->func_get_video_ex(get_img_frame, img_format);
			if(p){
				memcpy(img_data + (i * img_data_offs), p, img_data_size);
			}else{
				//fԂɂ
				req_abort = TRUE;
			}
		}
	}
}

//̑̔񓯊֐
void AUO_MT::async_func_proc(void)
{
	if(!req_abort){
		if(req_update_prv){
			pinfo_orig->func_update_preview();
			req_update_prv = false;
		}
		if((rest_disp_now != rest_disp_now_old) 
			|| (rest_disp_total != rest_disp_total_old))
		{
			pinfo_orig->func_rest_time_disp(rest_disp_now, rest_disp_total);
			rest_disp_total_old = rest_disp_total;
			rest_disp_now_old = rest_disp_now;
		}
		if(req_abort_chk){
			req_abort = pinfo_orig->func_is_abort();
			req_abort_chk = false;
		}
	}
}

//vtH[}bgύXꂽ
bool AUO_MT::on_format_change(void)
{
	if(img_format == get_img_fmt){
		return true;
	}

	//LbVς݃t[ԍe[uNA
	for(int j=0; j<buf_num; ++j) { img_data_n[j] = -1; }

	//tH[}bgύXꂽ̂Ńobt@UJ
	img_data_offs = img_data_size = 0;
	VirtualFree(img_data, 0, MEM_RELEASE);
	img_data = NULL;
	
	//obt@Ċm
	size_t data_offs,data_size;

	if(get_img_fmt == 0){
		//RGB24
		data_size = pinfo_orig->size;
	}else if(get_img_fmt == mmioFOURCC('Y', 'U', 'Y', '2')
		|| get_img_fmt == mmioFOURCC('2', 'Y', 'U', 'Y'))
	{
		//16bit/pix
		data_size = pinfo_orig->h * pinfo_orig->w * 2U;
	}else if(get_img_fmt == mmioFOURCC('Y', 'C', '4', '8')
		|| get_img_fmt == mmioFOURCC('8', '4', 'C', 'Y'))
	{
		//48bit/pix
		data_size = pinfo_orig->h * pinfo_orig->w * 6U;
	}else{
		//m̃tH[}bg
		return false;
	}
	data_offs = (data_size + 63U) & ~63U; //64oCg̔{

	img_data = static_cast<BYTE*>(VirtualAlloc(NULL,
		data_offs * buf_num, MEM_COMMIT | MEM_RESERVE, PAGE_READWRITE));
	if(NULL == img_data){
		show_message_box("obt@pmۂł܂łB"
			"ǂ݃obt@炵Ă݂ĂB");
		return false;
	}

	//Vp[^Zbg
	img_data_offs = data_offs;
	img_data_size = data_size;
	img_format = get_img_fmt;

	return true;
}

//LbV̓ǂݏo֐iLbVɖꍇ̓ubNēǂށj
void* AUO_MT::get_video_cached(int frame, DWORD format)
{
	int i;

	//tO̎擾
	i = frame%buf_num;
	if((img_data_n[i] != frame) || (img_format != format)){
		//LbV~XȂ̂ŃubNđ҂
		EnterCriticalSection(&cs_func);

		get_img_frame = frame;
		get_img_fmt = format;
		req = REQ_GET_VIDEO_EX;
		SetEvent(slp_event);

		//Cł̏I҂
		WaitForSingleObject(block_event, INFINITE);

		LeaveCriticalSection(&cs_func);
	}else{
		SetEvent(slp_event);
	}

	img_data_cur = frame;

	//G[̓f[^mۂĂȂꍇ̂
	if(img_data && img_data_offs){
		return img_data + (i * img_data_offs);
	}else{
		return NULL;
	}
}

int AUO_MT::get_flag_cached(int frame)
{
	int i;

	//tO̎擾
	i = frame%buf_num;
	if(img_flag_n[i] != frame){
		//LbV~XȂ̂ŃubNđ҂
		EnterCriticalSection(&cs_func);

		get_flag_frame = frame;
		req = REQ_GET_FLAG;
		SetEvent(slp_event);

		//Cł̏I҂
		WaitForSingleObject(block_event, INFINITE);

		LeaveCriticalSection(&cs_func);
	}else{
		SetEvent(slp_event);
	}

	img_flag_cur = frame;

	return img_flag[i];
}

// AUO_MTNX֐
//

//o͗pXbh
unsigned int __stdcall th_output(void *ptr)
{
	BOOL ret = TRUE;
	MSG msg;
	AUO_MT *pAMT = static_cast<AUO_MT*>(ptr);

	if(NULL == ptr){
		_endthreadex(FALSE);
		return FALSE;
	}

	//XbhɕKvȏ
	OleInitialize(NULL);
	AVIFileInit();

	//bZ[WL[쐬
	PeekMessage(&msg, NULL, WM_USER, WM_USER, PM_NOREMOVE);

	//CJn҂
	WaitForSingleObject(pAMT->block_event, INFINITE);

	//o̓vOCĂяo
	if(pAMT->ptbl->func_output){
		ret = pAMT->ptbl->func_output(&pAMT->oinfo);
	}

	//Iv
	pAMT->req = REQ_EXIT;
	SetEvent(pAMT->slp_event);

	AVIFileExit();
	OleUninitialize();

	_endthreadex((unsigned int)ret);
	return (unsigned int)ret;
}

//AviUtl API
void* __cdecl func_get_video_mt(int frame)
{
	return g_pAMT->get_video_cached(frame, 0);
}

void* __cdecl func_get_audio_mt(int start, int length, int *readed)
{
	void *ret;

	//ubN֐ی
	EnterCriticalSection(&g_pAMT->cs_func);
	
	g_pAMT->get_audio_start  = start;
	g_pAMT->get_audio_length = length;
	g_pAMT->get_audio_read = readed;
	g_pAMT->req = REQ_GET_AUDIO;
	SetEvent(g_pAMT->slp_event);

	//Cł̏I҂
	WaitForSingleObject(g_pAMT->block_event, INFINITE);
	ret = g_pAMT->get_audio_ret;

	LeaveCriticalSection(&g_pAMT->cs_func);

	return ret;
}

BOOL __cdecl func_is_abort_mt(void)
{
	MSG msg;

	//NGXĝݍsAۂɂ͏Ȃ
	g_pAMT->req_abort_chk = true;
	SetEvent(g_pAMT->slp_event);

	//o̓Xbhւ̃bZ[WfBXpb`
	while(PeekMessage(&msg, NULL, NULL, NULL, PM_REMOVE)){
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}

	return g_pAMT->req_abort;
}

BOOL func_rest_time_disp_mt(int now, int total)
{
	//NGXĝݍsAۂɂ͏Ȃ
	// ύX̂"now"݂̂ł\
	// ʂƂăAg~bNȂ̂ŔrȂĂ͖H
	g_pAMT->rest_disp_now = now;
	g_pAMT->rest_disp_total = total;

	SetEvent(g_pAMT->slp_event);
	return TRUE;
}

int __cdecl func_get_flag_mt(int frame)
{
	return g_pAMT->get_flag_cached(frame);
}

BOOL __cdecl func_update_preview_mt(void)
{
	//NGXĝݍsAۂɂ͏Ȃ
	g_pAMT->req_update_prv = true;

	SetEvent(g_pAMT->slp_event);
	return TRUE;
}

void* __cdecl func_get_video_ex_mt(int frame, DWORD format)
{
	return g_pAMT->get_video_cached(frame, format);
}
